;*******************************************************************************
;*
;*      Titel:  Unterprogramme zur Nutzung der seriellen Schnittstelle
;*              (SR_EIA232.asm)
;*
;*      Datum:  04/02/12        Version:        0.6 (31/1/2014)
;*      Autor:  WEIGU
;*
;*      Informationen zur Beschaltung:
;*      Prozessor:      ATmega32A/644p/32u4	Quarzfrequenz:  
;*      Eingaenge:
;*      Ausgaenge:
;*
;*      Informationen zur Funktionsweise:
;*
;*      
;*      Copyright (c) 2012   Guy WEILER         weigu[at]weigu[dot]lu
;*
;*      Hiermit wird unentgeltlich, jeder Person, die eine Kopie der Software
;*      und der zugehoerigen Dokumentationen (die "Software") erhaelt, die
;*      Erlaubnis erteilt, uneingeschraenkt zu benutzen, inklusive und ohne
;*      Ausnahme, dem Recht, sie zu verwenden, kopieren, aendern, fusionieren,
;*      verlegen, verbreiten, unterlizenzieren und/oder zu verkaufen, und
;*      Personen, die diese Software erhalten, diese Rechte zu geben, unter den
;*      folgenden Bedingungen:
;*
;*      ;Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in alle
;*      ;Kopien oder Teilkopien der Software beizulegen.
;*      ;
;*      ;DIE SOFTWARE WIRD OHNE JEDE AUSDRUECKLICHE ODER IMPLIZIERTE GARANTIE
;*      ;BEREITGESTELLT, EINSCHLIESSLICH DER GARANTIE ZUR BENUTZUNG FUER DEN
;*      ;VORGESEHENEN ODER EINEM BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTS-
;*      ;VERLETZUNG, JEDOCH NICHT DARAUF BESCHRAENKT. IN KEINEM FALL SIND DIE
;*      ;AUTOREN ODER COPYRIGHTINHABER FUER JEGLICHEN SCHADEN ODER SONSTIGE
;*      ;ANSPRUECHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFUELLUNG EINES
;*      ;VERTRAGES, EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER SOFTWARE
;*      ;ODER SONSTIGER VERWENDUNG DER SOFTWARE ENTSTANDEN.
;*
;*******************************************************************************

;Damit der Code im Flash gering bleibt werden ausschliesslich die benutzten
;Unterprogramme freigeschaltet (Flag = 1)
.EQU    Flag_E232INI  = 1	;Schnittstelle initialisieren (default = 1)
.EQU    Flag_E232INI2 = 0	;2 Schnittstelle initialisieren (mega644p)
.EQU    Flag_E232SND  = 1	;Polling Senden
.EQU    Flag_E232SND2 = 0	;Polling Senden 2 Schnittstelle (mega644p)
.EQU    Flag_E232RCV  = 1	;Polling Empfang
.EQU    Flag_E232RCV2 = 0	;Polling Empfang 2 Schnittstelle (mega644p)
.EQU    Flag_E232RCT  = 0	;Polling Empfang mit Timeout
.EQU    Flag_E232RCT2 = 0	;Polling Empfang  mit Timeout 2 Schnittstelle
.EQU    Flag_E232HEX  = 1	;Senden Hexzahl
.EQU    Flag_E232HEX2 = 0	;Senden Hexzahl 2 Schnittstelle (mega644p)
.EQU    Flag_E232DEZ  = 0       ;Senden Dezimal (SR_MATH muss eingebunden sein)
.EQU    Flag_ISRTX    = 1	;Interrupt Senden
.EQU    Flag_ISRTX2   = 0	;Interrupt Senden 2 Schnittstelle (mega644p)
.EQU    Flag_ISRRX    = 1	;Interrupt Empfang
.EQU    Flag_ISRRX2   = 0	;Interrupt Empfang 2 Schnittstelle (mega644p)
.EQU    Flag_E232CL   = 0	;"command list" ausgeben
.EQU    Flag_E232FL   = 0	;Leeren des Empfangsbuffer (flush)
.EQU    Flag_E232FL2  = 0	;Leeren Empfangsbuff. 2 Schnittstelle (mega644p)

;///////////////////////////////////////////////////////////////////////////////
;	Makros 
;	siehe http://www.mikrocontroller.net/articles/AVR_Assembler_Makros
;///////////////////////////////////////////////////////////////////////////////
;Bei neuen Chips liegen viele SF-Register ueber den 64 Adressen die mit den 
;Befehlen "in" und "out" zu erreichen sind. Fuer sie muessen "sts" und "lds"
;verwendet werden. Dies wird mit den folgenden beiden Makros erledigt. Statt der
;Befehle "in" und "out" werden in der Bibliothek die Makros "input" und "output"
;verwendet.

;Einlesen eines Ports mit input Arbeitsregister,SF-Register
.IFNDEF MACROINPUT
.SET	MACROINPUT = 1
  .MACRO input
    .IF @1 < 64
	in	@0, @1
    .ELSE
	lds	@0, @1
    .ENDIF
  .ENDM
.ENDIF

;Schreiben eines Ports mit output SF-Register,Arbeitsregister
.IFNDEF MACROOUTPUT
.SET	MACROOUTPUT = 1
  .MACRO output
    .IF @0 < 64
	out	@0, @1
    .ELSE
  	sts	@0, @1
    .ENDIF
  .ENDM
.ENDIF

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;       Reservierungen und Zuweisungen
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.DSEG
RX232FLAG:	.BYTE 1	        ;flag (ISRRX)
RX232FLAG2:     .BYTE 1		;flag (ISRRX2)
RX232DATA:      .BYTE 20        ;databuffer (max. 19 char + CR, ISRRX)
RX232DATA2:     .BYTE 20        ;databuffer (max. 19 char + CR, ISRRX2)
RX232P:         .BYTE 2         ;pointer databuffer (ISRRX)
RX232P2:        .BYTE 2         ;pointer databuffer2 (ISRRX2)
TX232P:         .BYTE 2         ;pointer for the TX interrupt routine
.CSEG

; Achtung Datenblatt beachten!
; Nicht alle Kombinationen liefern eine fehlerfreie Uebertragung
; Bei 16 MHz sind 9600, 19200 und 38400 Bit/s gute Werte
.EQU    EIA_Baud    = 9600	;Bitrate
.EQU    EIA_Baud2   = 9600      ;Bitrate 2 Schnittstelle (mega644p)
.EQU    E232TIMEOUT = 10000     ;Timeout*0,1ms fuer E232RCVT und E232RCVT	

.IFNDEF CPU_Clock
.EQU    CPU_Clock = 16000000    ;Systemtakt
.ENDIF

;ATmega32U4  !!! Achtung 1 serielle Schnittstelle USART1 an PD2 und PD3 !!!
.IF ((SIGNATURE_000 == 0x1E) && (SIGNATURE_001 == 0x95) && (SIGNATURE_002 == 0x87))
.EQU    UCSRA   = UCSR1A
.EQU    UCSRB   = UCSR1B
.EQU    UCSRC   = UCSR1C
.EQU    UBRRL   = UBRR1L
.EQU    UBRRH   = UBRR1H
.EQU    UDR     = UDR1
.EQU    UDRE    = UDRE1
.EQU    RXC     = RXC1
.EQU    TXEN    = TXEN1
.EQU    RXEN    = RXEN1
.EQU    UDRIE   = UDRIE1
.EQU    RXCIE  =  RXCIE1
.ENDIF

;ATmega644P  !!! 2 serielle Schnittstelle USART0 an PD0 und PD1 (USART1 PD2+3)!!
.IF ((SIGNATURE_000 == 0x1E) && (SIGNATURE_001 == 0x96) && (SIGNATURE_002 == 0x0A))
.EQU    UCSRA   = UCSR0A
.EQU    UCSRB   = UCSR0B
.EQU    UCSRC   = UCSR0C
.EQU    UBRRL   = UBRR0L
.EQU    UBRRH   = UBRR0H
.EQU    UDR     = UDR0
.EQU    UDRE    = UDRE0
.EQU    RXC     = RXC0
.EQU    TXEN    = TXEN0
.EQU    RXEN    = RXEN0
.EQU    UDRIE   = UDRIE0
.EQU    RXCIE   = RXCIE0
.ENDIF

;-------------------------------------------------------------------------------
;       EIA 232 (USART) initialisieren (Datenformat 8N1)
;-------------------------------------------------------------------------------
.IF Flag_E232INI == 1
E232INI: push	r16
	;Sender und Empfaenger einschalten und Datenformat festlegen
.IF ((Flag_ISRTX == 1) || (Flag_E232SND == 1))
	input   r16,UCSRB
        ori	r16,0x08        ;Sender einschalten (TxEnable, Bit 3)
        output  UCSRB,r16        	
.ENDIF
.IF ((Flag_ISRRX == 1) || (Flag_E232RCV  == 1))
        input   r16,UCSRB
        ori	r16,0x10	;Empfaenger einschalten (RxEnable Bit 4)
        output  UCSRB,r16        
.ENDIF
.IF Flag_ISRRX == 1                
        input   r16,UCSRB
        ori	r16,0x80	;Empfangsinterrupt (RXCIE) freigeben
        output  UCSRB,r16        			
.ENDIF	
        ldi     r16,0x86        ;UCSRC = 0b10000110
        output  UCSRC,r16       ;Waehle Asynchr. 8N1
                                ;B7 URSEL=1 UCSRC ausgewaehlt
                                ;B6 UMSEL=0 Asynchron
                                ;B45 UPM=00 keine Paritaet
                                ;B3 USBS=0 1 Stoppbit
                                ;B21 UCSZ=11 8 Datenbit
                                ;B0 UCPOL=0 bei Asyn.
        ;Baudrate initialisieren (Teiler fuer Baudrate festlegen)
        ldi     r16,HIGH((CPU_Clock/(EIA_Baud*16))-1)        
        output  UBRRH,r16              
        ldi     r16,LOW((CPU_Clock/(EIA_Baud*16))-1)
        output  UBRRL,r16  
        
.IF Flag_ISRRX == 1        
	sts	RX232FLAG,Zero	        ;Flag fuer die Routine ISRRX loeschen	
	ldi     r16,HIGH(RX232DATA)     ;Pointer initialisieren (ISRRX)
	sts     RX232P,r16
        ldi     r16,LOW(RX232DATA)
        sts     RX232P+1,r16
        ldi     r16,20                  ;clear the buffer
        ldi     XL,LOW(RX232DATA)       
        ldi     XH,HIGH(RX232DATA)
E232INL: st     X+,Zero
        dec     r16
        brne    E232INL

.ENDIF                
        pop	r16
        ret
.ENDIF

;-------------------------------------------------------------------------------
;       EIA 232 (USART) initialisieren (8N1) 2 Schnittstelle (mega644p)
;-------------------------------------------------------------------------------
.IF Flag_E232INI2 == 1
E232INI2: push	r16
	;Sender und Empfaenger einschalten und Datenformat festlegen
.IF ((Flag_ISRTX2 == 1) || (Flag_E232SND2 == 1))
	input   r16,UCSR1B
        ori	r16,0x08        ;Sender einschalten (TxEnable, Bit 3)
        output  UCSR1B,r16        	
.ENDIF
.IF ((Flag_ISRRX2 == 1) || (Flag_E232RCV2  == 1))
        input   r16,UCSR1B
        ori	r16,0x10	;Empfaenger einschalten (RxEnable Bit 4)
        output  UCSR1B,r16        
.ENDIF
.IF Flag_ISRRX2 == 1                
        input   r16,UCSR1B
        ori	r16,0x80	;Empfangsinterrupt (RXCIE) freigeben
        output  UCSR1B,r16        			
.ENDIF
	ldi     r16,0x06        ;UCSRC = 10000110b
        output  UCSR1C,r16      ;Waehle Asynchr. 8N1
                                ;B7 URSEL=1 UCSRC ausgewaehlt
                                ;B6 UMSEL=0 Asynchron
                                ;B45 UPM=00 keine Paritaet
                                ;B3 USBS=0 1 Stoppbit
                                ;B21 UCSZ=11 8 Datenbit
                                ;B0 UCPOL=0 bei Asyn.
        ;Baudrate initialisieren (Teiler fuer Baudrate festlegen)
        ldi     r16,HIGH((CPU_Clock/(EIA_Baud2*16))-1)        
        output  UBRR1H,r16              
        ldi     r16,LOW((CPU_Clock/(EIA_Baud2*16))-1)
        output  UBRR1L,r16  
        
.IF Flag_ISRRX2 == 1        
	sts	RX232FLAG2,Zero	        ;Flag fuer die Routine ISRRX loeschen	
        ldi     r16,HIGH(RX232DATA2)    ;Pointer initialisieren (ISRRX) setzen
        sts     RX232P2,r16
        ldi     r16,LOW(RX232DATA2) 
        sts     RX232P2+1,r16
        ldi     r16,20                  ;clear the buffer
        ldi     XL,LOW(RX232DATA2)       
        ldi     XH,HIGH(RX232DATA2)
E232IN2L: st    X+,Zero
        dec     r16
        brne    E232IN2L

.ENDIF                
        pop	r16
        ret
.ENDIF

;===============================================================================
;       Polling
;===============================================================================
;-------------------------------------------------------------------------------
;       Senden eines Zeichens (Parameter r24)
;-------------------------------------------------------------------------------
.IF Flag_E232SND == 1
E232SND: push	r16 
E232SL: input	r16,UCSRA	;Warte bis UDREmpty gesetzt ist, da der Schreib-
	sbrs	r16,UDRE	;versuch sonst ignoriert wird        	
        rjmp    E232SL         
        output  UDR,r24         ;und gib das Zeichen aus        
        pop	r16
        ret
.ENDIF        

;-------------------------------------------------------------------------------
;       Senden eines Zeichens (Parameter r24) 2 Schnittstelle (mega644p)
;-------------------------------------------------------------------------------
.IF Flag_E232SND2 == 1
E232SND2: push	r16 
E232SL2: input	r16,UCSR1A	;Warte bis UDREmpty gesetzt ist, da der Schreib-
	sbrs	r16,UDRE1	;versuch sonst ignoriert wird        	
        rjmp    E232SL2         
        output  UDR1,r24         ;und gib das Zeichen aus        
        pop	r16
        ret
.ENDIF        

;-------------------------------------------------------------------------------
;       Empfang eines Zeichens (Zeichen r24, Fehler in r25) 2 Schnittstelle
;       (mega644p)
;-------------------------------------------------------------------------------
.IF Flag_E232RCV == 1
E232RCV: input r25,UCSRA	;Warte bis RXC (Receive Complete) gesetzt
	sbrs	r25,RXC		
        rjmp    E232RCV
        input   r25,UCSRA       ;UCSRA einlesen und Fehlerflags maskieren
        andi    r25,0b00011100  
	input	r24,UDR		;Zeichen einlesen
        ret
.ENDIF        

;-------------------------------------------------------------------------------
;       Empfang eines Zeichens (Zeichen r24, Fehler in r25) 2 Schnittstelle
;       (mega644p)
;-------------------------------------------------------------------------------
.IF Flag_E232RCV2 == 1
E232RCV2: input r25,UCSR1A	;Warte bis RXC (Receive Complete) gesetzt
	sbrs	r25,RXC1	
        rjmp    E232RCV2
        input   r25,UCSR1A      ;UCSR1A einlesen und Fehlerflags maskieren
        andi    r25,0b00011100  
	input	r24,UDR1	;Zeichen einlesen
        ret
.ENDIF        

;-------------------------------------------------------------------------------
;       Empfang eines Zeichens mit TimeOut
;       (Zeichen r24, Fehler in r25)
;-------------------------------------------------------------------------------
.IF Flag_E232RCT == 1
E232RCT: push	r16
		
	ldi	r25,HIGH(E232TIMEOUT)
	ldi	r24,LOW(E232TIMEOUT)	
E232RCL: rcall	W10us
	sbiw	r24,1
	breq	E232RCR	
	input r16,UCSRA		;Warte bis RXC (Receive Complete) gesetzt
	sbrs	r16,RXC		
        rjmp    E232RCL
        
        input   r25,UCSRA      ;UCSRA einlesen und Fehlerflags maskieren
        andi    r25,0b00011100  
	input	r24,UDR		;Zeichen einlesen

E232RCR: pop	r16
        ret
.ENDIF        

;-------------------------------------------------------------------------------
;       Empfang eines Zeichens mit TimeOut
;       (Zeichen r24, Fehler in r25) 2 Schnittstelle (mega644p)
;-------------------------------------------------------------------------------
.IF Flag_E232RCT2 == 1
E232RCT2: push	r16
		
	ldi	r25,HIGH(E232TIMEOUT)
	ldi	r24,LOW(E232TIMEOUT)	
E232RCL2: rcall	W10us
	sbiw	r24,1
	breq	E232RCR2	
	input r16,UCSR1A	;Warte bis RXC (Receive Complete) gesetzt
	sbrs	r16,RXC1		
        rjmp    E232RCL2
        
        input   r25,UCSR1A      ;UCSR1A einlesen und Fehlerflags maskieren
        andi    r25,0b00011100  
	input	r24,UDR1	;Zeichen einlesen

E232RCR2: pop	r16
        ret
.ENDIF        

;-------------------------------------------------------------------------------
;       Senden eines Bytes in Hexadezimal (Parameter r24)
;       Ausgabe: 2 Zeichen+Space
;-------------------------------------------------------------------------------        
.IF Flag_E232HEX == 1
E232HEX:
	push	r16	
	push	r17
	push	r24
	push	r25
	
	ldi	r16,0x30	;ASCII Offset Ziffer
	ldi	r17,0x37	;ASCII Offset Grossbuchstabe
	
	mov	r25,r24
	andi	r24,0xF0
	swap	r24	
	cpi	r24,10
	brge	E232H1
	add	r24,r16	
	rjmp	E232H2
E232H1:	add	r24,r17	
E232H2:	rcall	E232SND	
	mov	r24,r25
	andi	r24,0x0F
	cpi	r24,10
	brge	E232H3
	add	r24,r16	
	rjmp	E232H4
E232H3:	add	r24,r17		
E232H4:	rcall	E232SND	
	ldi	r24,' '
	rcall	E232SND
	
	pop	r25
	pop	r24
	pop	r17
	pop	r16
	ret
.ENDIF        

;-------------------------------------------------------------------------------
;       Senden eines Bytes in Dezimal (Parameter r24)
;       Ausgabe: 3 Zeichen+Space
;       Bibliothek SR_MATH muss eingebunden sein
;-------------------------------------------------------------------------------        
.IF Flag_E232DEZ == 1
E232DEZ: push    r24
        rcall   DEC2A3
        lds     r24,TDEC2A+0
        rcall   E232SND 
        lds     r24,TDEC2A+0
        rcall   E232SND 
        lds     r24,TDEC2A+0
        rcall   E232SND 
        ldi     r24,' '
        rcall   E232SND 
	pop	r24
	ret
.ENDIF        

;===============================================================================
;       Interrupt
;===============================================================================
;-------------------------------------------------------------------------------
;	Interrupt routine 
;       Send a char to EIA232
;	
;	initialise the interrupt vector the main programm:
;	.ORG	UDREaddr (bzw. UDRE1addr)
;		rjmp	ISRTX
;       initialise EIA232 in the main programm
;	        rcall	E232INI
;		
;	The text (Flash) has to end with NUL (null character, 0).
;       The pointer has to be initialized to the first character of the text. 
;       The UDRE interrupt has to enabled before sending.
;       Example code:
;       
;	        ldi	r16,HIGH(TEXT*2) 	;initialize pointer
;               sts     TX232P+0,r16
;               ldi     r16,LOW(TEXT*2)       
;               sts     TX232P+1,r16
;		input   r16,UCSRB	        ;enable UDRIE
;       	ori	r16,0x20         
;       	output  UCSRB,r16        	
;	TEXT:	.DB	"Hallo",0
;-------------------------------------------------------------------------------
.IF Flag_ISRTX == 1
ISRTX:  push    r16             
        in      r16,SREG        
        push    r16             
        push    ZL
        push    ZH

        lds     ZH,TX232P+0     ;get pointer
        lds     ZL,TX232P+1
        lpm	r16,Z+		;get char, incr pointer

        cpi	r16,0		;return if null character
	breq	ISRTXC			
        output	UDR,r16		;Zeichen ausgeben
        sts     TX232P+0,ZH     ;restore pointer
        sts     TX232P+1,ZL
	rjmp	ISRTXR

ISRTXC:	input   r16,UCSRB	;disable UDRE interrupt (UDRIE = 0)
        andi	r16,0xDF         
       	output  UCSRB,r16        	

ISRTXR:	pop     ZH
        pop     ZL
        pop     r16             
        out     SREG,r16        
        pop     r16             
        reti    		
.ENDIF    

;-------------------------------------------------------------------------------
;	Interrupt Routine zum Empfang von Zeichen (Befehlen) ueber EIA232
;	
;	;	Im Hauptprogramm muss der Interruptvektor initialisiert werden:
;	.ORG	URXCaddr (bzw.URXC1addr)
;		rjmp	ISRRX
;	
;	E232INI muss in der Initialisierungsphase aufgerufen werden
;		rcall	E232INI
;	
;	Die Routine speichert Text bis "Carriage Return" (0x0D) empfangen
;       wird (SRAM RX232DATA, maximal 19 Zeichen).
;       Wurde CR empfangen, so wird ein Flag gesetzt (RX232FLAG = 0xFF)
;	          
;-------------------------------------------------------------------------------
.IF Flag_ISRRX == 1
ISRRX:  push    r16 
        in      r16,SREG 
        push    r16      
	push    r17    
	push    XL    
	push    XH    
	
	lds     r16,RX232FLAG   ;if flag set then ignore char
	cpi     r16,0xFF
	breq    ISRRXR
		
        lds     XH,RX232P       ;read pointer
        lds     XL,RX232P+1

        input   r16,UDR         ;read and save char
	st      X+,r16          ;inc pointer
	
	cpi     r16,0x0D        ;if char=CR return
	breq    ISRRXT
	
	sts     RX232P,XH       ;save pointer
        sts     RX232P+1,XL
        rjmp    ISRRXR          ;and return

ISRRXT: ldi     r16,HIGH(RX232DATA)  ;reset pointer
        sts     RX232P,r16
        ldi     r16,LOW(RX232DATA)  
        sts     RX232P+1,r16
        lds     r16,RX232DATA   ;the command to set the RTC must be processed
        cpi     r16,'t'         ;immediatly to avoid delays (dont set the flag)
        brne    ISRRXT2        
        rcall   COM_T           ;see "SR_COMMANDS.asm"
        ldi     r16,19          ;clear the buffer
        ldi     XL,LOW(RX232DATA)       
        ldi     XH,HIGH(RX232DATA)
ISRRXL: st      X+,Zero
        dec     r16
        brne    ISRRXL
        rjmp    ISRRXR

ISRRXT2: ser     r16            ;set the flag (0xFF)
        sts     RX232FLAG,r16	

ISRRXR:	pop     XH    
        pop     XL    
        pop	r17
	pop     r16             ;SREG-Register (Flags) wiederherstellen
        out     SREG,r16        ;
        pop     r16             ;r16 wiederherstellen
        reti    		;zurueck und Interrupts wieder freigeben
.ENDIF    

;-------------------------------------------------------------------------------
;	Leeren des Empfangsbuffers (to flush = ausbluten, ausspuelen)
;-------------------------------------------------------------------------------
.IF Flag_E232FL == 1
E232FL: push	r16
E232F1:	input	r16,UCSRA
	sbrs	r16,RXC
	rjmp	E232FR	
	input 	r16,UDR
	rjmp 	E232F1
E232FR: pop	r16
	ret
.ENDIF    
;-------------------------------------------------------------------------------
;	Leeren des Empfangsbuffers 2 Schnittstelle (mega644p)
;-------------------------------------------------------------------------------
.IF Flag_E232FL2 == 1
E232FL2: push	r16
E232F21: input	r16,UCSR1A
	sbrs	r16,RXC1
	rjmp	E232F2R	
	input 	r16,UDR1
	rjmp 	E232F21
E232F2R: pop	r16
	ret
.ENDIF    


