;*******************************************************************************
;*
;*      Titel:  Unterprogramm zur Umcodieren
;*              (SR_RECODE.asm)
;*
;*      Datum:  13/02/12        Version:        0.1
;*      Autor:  WEIGU
;*
;*      Informationen zur Beschaltung:
;*      Prozessor:      ATmega32A/644p/32u4	Quarzfrequenz:  
;*      Eingaenge:
;*      Ausgaenge:
;*
;*      Informationen zur Funktionsweise:
;*      
;*      
;*      
;*      Unterprogramme:
;*      RTCSND:	Daten zum DS1307 senden (8 Datenbyte)
;*
;*      
;*      Copyright (c) 2012   Guy WEILER         weigu[at]weigu[dot]lu
;*
;*      Hiermit wird unentgeltlich, jeder Person, die eine Kopie der Software
;*      und der zugehoerigen Dokumentationen (die "Software") erhaelt, die
;*      Erlaubnis erteilt, uneingeschraenkt zu benutzen, inklusive und ohne
;*      Ausnahme, dem Recht, sie zu verwenden, kopieren, aendern, fusionieren,
;*      verlegen, verbreiten, unterlizenzieren und/oder zu verkaufen, und
;*      Personen, die diese Software erhalten, diese Rechte zu geben, unter den
;*      folgenden Bedingungen:
;*
;*      ;Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in alle
;*      ;Kopien oder Teilkopien der Software beizulegen.
;*      ;
;*      ;DIE SOFTWARE WIRD OHNE JEDE AUSDRUECKLICHE ODER IMPLIZIERTE GARANTIE
;*      ;BEREITGESTELLT, EINSCHLIESSLICH DER GARANTIE ZUR BENUTZUNG FUER DEN
;*      ;VORGESEHENEN ODER EINEM BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTS-
;*      ;VERLETZUNG, JEDOCH NICHT DARAUF BESCHRAENKT. IN KEINEM FALL SIND DIE
;*      ;AUTOREN ODER COPYRIGHTINHABER FUER JEGLICHEN SCHADEN ODER SONSTIGE
;*      ;ANSPRUECHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFUELLUNG EINES
;*      ;VERTRAGES, EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER SOFTWARE
;*      ;ODER SONSTIGER VERWENDUNG DER SOFTWARE ENTSTANDEN.
;*
;*******************************************************************************
;Damit der Code im Flash gering bleibt werden ausschliesslich die benutzten
;Unterprogramme freigeschaltet (Flag = 1)
.EQU    Flag_BCD2ASC  = 1	;BCD nach ASCII
.EQU    Flag_ASCD2BIN = 1	;ASCII Dezimal 2 Byte nach Binaer
.EQU    Flag_ASCH2BIN = 1	;ASCII Hexadezimal 2 Byte nach Binaer
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;       Reservierungen und Zuweisungen
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


;-------------------------------------------------------------------------------
;	BCD nach ASCII (BCD in r24, ASCII in r25:r24)
;-------------------------------------------------------------------------------
.IF Flag_BCD2ASC == 1
BCD2ASC:
	push	r16
	push	r17	
	ldi	r16,0x30	
	mov	r17,r24
	andi	r24,0xF0
	swap	r24	
	add	r24,r16	
	mov	r25,r24
	mov	r24,r17
	andi	r24,0x0F
	add	r24,r16
	pop	r17
	pop	r16
	ret
.ENDIF	

;-------------------------------------------------------------------------------
;	ASCII (2 Byte) Dezimal nach Binaer (ASCII D in r25:r24, Binaer in r24 )
;-------------------------------------------------------------------------------
.IF Flag_ASCD2BIN == 1
ASCD2BIN:
	push	r16	
	ldi	r16,10	
	subi	r25,0x30	
	subi	r24,0x30	
	mul	r25,r16
	add	r24,r0
	pop	r16
	ret
.ENDIF	

;-------------------------------------------------------------------------------
;	ASCII (2 Byte) Hexadezimal nach Binaer (ASCII H in r25:r24, Bin in r24 )
;-------------------------------------------------------------------------------
.IF Flag_ASCH2BIN == 1
ASCH2BIN: subi	r25,0x30	
	subi	r24,0x30	
	cpi	r25,0x0A
	brlo	ASCH2BIN2
	cpi	r25,0x31
	brlo	ASCH2BIN1	;Grossbuchstabe A-F
	subi	r25,0x27	;Kleinbuchstabe a-f
	rjmp	ASCH2BIN2
ASCH2BIN1: subi	r25,0x07	
ASCH2BIN2: cpi	r24,0x0A
	brlo	ASCH2BIN4
	cpi	r24,0x31
	brlo	ASCH2BIN3	;Grossbuchstabe A-F
	subi	r24,0x27	;Kleinbuchstabe a-f
	rjmp	ASCH2BIN2
ASCH2BIN3: subi	r24,0x07	
ASCH2BIN4: lsl 	r25		;Highbyte*16
	lsl 	r25
	lsl 	r25
	lsl 	r25
	add	r24,r25
	ret
.ENDIF	
